searchData={"items":[{"type":"module","title":"OneDHCPD","doc":"The One Address DHCP Server!\n\nThis is a simple DHCP server for supplying IP addresses on point-to-point\nEthernet links.  To use it, specify a static IPv4 address on the Ethernet\ninterface and then start the server up.  OneDHCPD can supply an IPv4 address\nfor you by calling `OneDHCPD.default_ip_address/1` that should minimize IP\nconflicts with the user's network and other OneDHCPD servers. This is the\nrecommended approach.\n\nOneDHCPD is mostly used behinds the scenes with VintageNet. Here's an example\nfor using it with a virtual USB ethernet interface:\n\n```elixir\niex> VintageNet.configure(\"usb0\", %{type: VintageNetDirect})\n:ok\n```\n\nThe Nerves new project generator adds this configuration by default. If you'd\nlike more information, see the\n[VintageNetDirect[(https://hexdocs.pm/vintage_net_direct/VintageNetDirect.html)\ndocumentation.","ref":"OneDHCPD.html"},{"type":"function","title":"OneDHCPD.default_ip_address/1","doc":"Return the default server IP address that would be used for the specified\ninterface.","ref":"OneDHCPD.html#default_ip_address/1"},{"type":"function","title":"OneDHCPD.default_subnet_mask/0","doc":"Return the subnet mask that goes along with default_ip_address/1.","ref":"OneDHCPD.html#default_subnet_mask/0"},{"type":"module","title":"OneDHCPD.ARP","doc":"This module contains utilities to view or update the ARP cache.\n\nOneDHCPD uses this to update the ARP cache when the IP address is given\nout. If networking isn't working, `OneDHCPD.ARP.entries/0` is useful\nfor debugging.","ref":"OneDHCPD.ARP.html"},{"type":"function","title":"OneDHCPD.ARP.entries/0","doc":"Query the ARP cache and return everything in it.\n\nCurrently this function is only used for debug.","ref":"OneDHCPD.ARP.html#entries/0"},{"type":"function","title":"OneDHCPD.ARP.replace/3","doc":"Replace an entry in the ARP cache.","ref":"OneDHCPD.ARP.html#replace/3"},{"type":"module","title":"OneDHCPD.ARP.Entry","doc":"One entry in the ARP table","ref":"OneDHCPD.ARP.Entry.html"},{"type":"type","title":"OneDHCPD.ARP.Entry.t/0","doc":"","ref":"OneDHCPD.ARP.Entry.html#t:t/0"},{"type":"module","title":"OneDHCPD.IPCalculator","doc":"This module handles IP address calculations.\n\nThe most involved of the calculations is the determination of a good IP\nsubnet to use. OneDHCPD subnet tries for the following:\n\n* Subnets should be the same across reboots (convenience and no surprise conflicts)\n* Support running on more than one interface (unique subnets on device)\n* Support hosts than have more than one device (unique subnets between\n  devices)\n* Don't conflict with the IPs used on the host for Internet\n\nThe algorithm here is to hash the hostname (uniqueness between devices\nassuming the hostname is unique) and the network interface (uniqueness on\ndevice). Then use those bits to pick a subnet in the 172.31.0.0/16\nprivate address range. That private range was picked arbitrarily since\n10.0.0.0/8 and 192.168.0.0/16 ranges are commonly used. 172.18.0.0/16\nis used by Docker.","ref":"OneDHCPD.IPCalculator.html"},{"type":"function","title":"OneDHCPD.IPCalculator.default_subnet/1","doc":"Calculate the default subnet for the specified Ethernet interface.","ref":"OneDHCPD.IPCalculator.html#default_subnet/1"},{"type":"function","title":"OneDHCPD.IPCalculator.default_subnet/2","doc":"Calculate the default subnet for the specified Ethernet interface\nand specify the hostname manually.","ref":"OneDHCPD.IPCalculator.html#default_subnet/2"},{"type":"function","title":"OneDHCPD.IPCalculator.mask/0","doc":"Return the subnet mask.\n\nCurrently this is hardcoded to a /30 network.","ref":"OneDHCPD.IPCalculator.html#mask/0"},{"type":"function","title":"OneDHCPD.IPCalculator.our_ip_address/1","doc":"Return our IP address. This is the one that should be set\nas a static address on the interface if using the defaults.","ref":"OneDHCPD.IPCalculator.html#our_ip_address/1"},{"type":"function","title":"OneDHCPD.IPCalculator.prefix_length/0","doc":"Return the prefix length that OneDHCPD uses.","ref":"OneDHCPD.IPCalculator.html#prefix_length/0"},{"type":"function","title":"OneDHCPD.IPCalculator.their_ip_address/1","doc":"Return the IP address that's given out to the client.","ref":"OneDHCPD.IPCalculator.html#their_ip_address/1"},{"type":"module","title":"OneDHCPD.Message","doc":"DHCP Message\n\nSee [RFC2131](https://tools.ietf.org/html/rfc2131) and associated docs\nfor details. This implementation is only intended to be complete enough\nto support the OneDHCPD use case.","ref":"OneDHCPD.Message.html"},{"type":"function","title":"OneDHCPD.Message.decode/1","doc":"Decode the contents of a UDP packet","ref":"OneDHCPD.Message.html#decode/1"},{"type":"function","title":"OneDHCPD.Message.encode/1","doc":"Encode a message so that it can be put in a UDP packet","ref":"OneDHCPD.Message.html#encode/1"},{"type":"function","title":"OneDHCPD.Message.response/1","doc":"Create a response to a request with some fields filled in.\n\nSee RFC 2131 Table 3 for requirements. The caller is responsible for\nmost of the fields.","ref":"OneDHCPD.Message.html#response/1"},{"type":"type","title":"OneDHCPD.Message.t/0","doc":"","ref":"OneDHCPD.Message.html#t:t/0"},{"type":"module","title":"OneDHCPD.Server","doc":"This is the OneDHCPD Server.\n\nAdd it to a supervision tree in your application to use. E.g.,\n\n```elixir\n{OneDHCPD.Server, [\"usb0\", [subnet: {172, 31, 246, 64}]}\n```","ref":"OneDHCPD.Server.html"},{"type":"function","title":"OneDHCPD.Server.start_link/2","doc":"Start a DHCP Server that works for one client\n\nOptions:\n\n* `port` - the port for the server (only specify if testing)\n* `subnet` - a /30 subnet to allocate addresses (default is {192, 168, 200, 0})","ref":"OneDHCPD.Server.html#start_link/2"},{"type":"function","title":"OneDHCPD.Server.stop/1","doc":"","ref":"OneDHCPD.Server.html#stop/1"},{"type":"type","title":"OneDHCPD.Server.t/0","doc":"","ref":"OneDHCPD.Server.html#t:t/0"},{"type":"extras","title":"one_dhcpd","doc":"# one_dhcpd\n\n[![CircleCI](https://circleci.com/gh/fhunleth/one_dhcpd.svg?style=svg)](https://circleci.com/gh/fhunleth/one_dhcpd)\n[![Hex version](https://img.shields.io/hexpm/v/one_dhcpd.svg \"Hex version\")](https://hex.pm/packages/one_dhcpd)\n\nThis is a simple DHCP server that's capable of giving out just one IP address.\nThe use case is to support connecting Nerves devices directly to laptops. Yes,\nthere are many ways of solving this problem. It took a long time to give up on\nthe available alternatives and write this, and we may end up abandoning this\nproject. Until then, there's `one_dhcpd`.\n\nIf you're looking for a DHCP server, check out\n[dhcp_server](https://hex.pm/packages/dhcp_server). Note that since this project\nwas developed independent of that one, we were able to change the license to\nApache-2.0 to be in line with other Nerves projects.","ref":"readme.html"},{"type":"extras","title":"Usage - one_dhcpd","doc":"Before using this directly, check whether you can use it via\n[`vintage_net_direct`](https://hex.pm/packages/vintage_net_direct).\n\nIf you'd like to manually use this, see the [Hex\ndocs](https://hexdocs.pm/one_dhcpd) for details.","ref":"readme.html#usage"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v2.0.3 - 2024-6-5 - Changelog","doc":"* Changes\n  * Fix Elixir 1.17 deprecation warnings","ref":"changelog.html#v2-0-3-2024-6-5"},{"type":"extras","title":"v2.0.2 - 2023-2-12 - Changelog","doc":"* Changes\n  * Fix Elixir 1.15 deprecation warnings","ref":"changelog.html#v2-0-2-2023-2-12"},{"type":"extras","title":"v2.0.1 - 2022-8-4 - Changelog","doc":"* Changes\n  * Fix Elixir 1.14 warning during compilation\n  * Raise minimum Elixir version to 1.11 similar to other Nerves-related\n    libraries. It should still work, but it's no longer verified on CI, and I'm\n    no longer supporting issues with earlier Elixir versions.","ref":"changelog.html#v2-0-1-2022-8-4"},{"type":"extras","title":"v2.0.0 - 2022-3-6 - Changelog","doc":"This release removes `OneDHCPD.start_server/2` and makes OneDHCPD a library\nrather than an OTP Application. If you're using `VintageNetDirect`, you won't\nnotice this change since it didn't use `OneDHCPD.start_server/2` anyway. If\nyou're using `OneDHCPD.start_server/2`, then add `OneDHCP.Server` to your\napplication's supervision tree.","ref":"changelog.html#v2-0-0-2022-3-6"},{"type":"extras","title":"v1.0.0 - 2021-10-28 - Changelog","doc":"This release bumps the version number to 1.0.0. No functional changes were made.\n\n* Improvements\n  * Minor code and documention cleanup","ref":"changelog.html#v1-0-0-2021-10-28"},{"type":"extras","title":"v0.2.5 - Changelog","doc":"* Bug fixes\n  * Fix missing `:crypto` dependency warning on Elixir 1.11","ref":"changelog.html#v0-2-5"},{"type":"extras","title":"v0.2.4 - Changelog","doc":"* Bug fixes\n  * Fix C compiler warning","ref":"changelog.html#v0-2-4"},{"type":"extras","title":"v0.2.3 - Changelog","doc":"* Improvements\n  * Added `OneDHCPD.prefix_length()` for a more convenient integration with\n    `vintage_net`\n\n* Bug fixes\n  * Non-code affecting Dialyzer and compiler warning fixes\n  * Fixed a currently unused DHCP option encoder (found when Dialyzing)","ref":"changelog.html#v0-2-3"},{"type":"extras","title":"v0.2.2 - Changelog","doc":"* Bug fixes\n  * Switch from 172.16.0.0/12 to 172.31.0.0/16 for the default addresses. This\n    avoids conflicts with Docker's use of 172.18.0.0/16.","ref":"changelog.html#v0-2-2"},{"type":"extras","title":"v0.2.1 - Changelog","doc":"* Bug fixes\n  * Move build products under `_build` so that it's not required to build clean\n    between switching targets.","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"* Bug fixes\n  * Send DHCP NAKs when clients request the wrong IP address. Speeds up getting\n    the right address when switching networks.","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"Initial release","ref":"changelog.html#v0-1-0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}